/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
/* $Id: wzeichne.c,v 1.31 2004/04/10 19:01:36 fzk Exp $ */

/* Zeichnen des Wuerfelguertels mit Mesa 3-D */

#ifndef OS_WIN32
  #include <config.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#ifndef OS_WIN32
#include <sys/time.h>
#endif
/* #include <sys/types.h> */
#include "wuerfel.h"

static int    callFill, callLines, callVirt, callAxis, callTimeform, callTouchline;

void
zeichnewg (void) {
    unsigned int width;
    unsigned int height;

    rotx = roty = rotz = tranx = trany = tranz = 0.;
    drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
    waittime.tv_sec = 0;
    waittime.tv_usec = 100000;

    if (options.position == -1) {
        halt = FALSE;
    }
    else {
        halt = TRUE;
    }

    if (options.seite == 0) {
        width = FENSTER /* DisplayWidth (display, screen) / 2 */ ;
        height = width;
        options.seite = width;
    }
    else {
        width = height = options.seite;
    }

    glutInitWindowSize (options.seite, options.seite);
       /* glutInitWindowPosition (0, 0); */

    winIdMain = glutCreateWindow ("Der umstlpbare Wrfel nach Paul Schatz");

    owgp = wg;

    glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glEnable (GL_DEPTH_TEST);
    glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

    WglCreateDisplayLists ();

    glutKeyboardFunc (WglKey);
    glutSpecialFunc (WglSpecialKey);
    glutDisplayFunc (WglDisplay);
    glutReshapeFunc (WglReshape);
    glutIdleFunc (WglIdle);

    WglCreateMenus ();

    winIdSub =  glutCreateSubWindow (winIdMain, 0, 0, options.seite, options.seite / 7);
    glutDisplayFunc (WglSubDisplay);
    glutReshapeFunc (WglSubReshape);

    glutMainLoop ();
}

void
WglDisplay (void) {

/*   static int gdf = 0; */
/*   fprintf (stderr, "glutDisplayFunc %d\n", ++gdf); */

    glutSetWindow (winIdMain);
    glClearColor (0.7, 0.7, 0.0, 0.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glLoadIdentity ();

    glTranslatef (tranx + dtranx, trany + dtrany, tranz + dtranz - 5.);

    glRotatef (rotx + drotx, 1.0, 0.0, 0.0);
    glRotatef (roty + droty, 0.0, 1.0, 0.0);
    glRotatef (rotz + drotz, 0.0, 0.0, 1.0);

    if (options.mode == 3) {
        glRotatef (GWINKEL(owgp->wgp.w2), 1.0, 0.0, 0.0);
    }
    if (options.mode == 2 || options.mode == 3) {
        glRotatef (GWINKEL(owgp->wgp.w), 0.0, 1.0, 0.0);
    }

    callFill = callLines = callVirt = callAxis = callTimeform = callTouchline = 0;

    if (options.position != -1) {
      fprintf (stderr, "Position=%d, weiter mit den Tasten 's', Punkt oder Komma\n",
	       options.position);
/*       options.position = options.position % (int)(M_PI / options.dw); */

      listIdLines = listIdLinesStart + options.position;
      listIdFill = listIdFillStart + options.position;
      listIdVirt = listIdVirtStart + options.position;
      listIdAxis = listIdAxisStart + options.position;
      listIdTouch = listIdTouchStart + options.position;

/*       callFill += options.position; */
/*       callLines += options.position; */
/*       callVirt += options.position; */
/*       callAxis += options.position; */
/*       callTimeform += options.position; */
/*       callTouchline += options.position; */

      while (options.position > 0) {
	  owgp = (owgp->nextwgp?owgp->nextwgp:owgp);
	  options.position--;
      }
      options.position = -1;
    }


    if (polygonMode == GL_FILL) {
      if (options.wuerfel) {
        glCallList (listIdFill);
      }
    }
    else {
      if (options.wuerfel) {
        glCallList (listIdLines);
      }
    }

    if (options.virtuell) {
        glCallList (listIdVirt);
    }

    if (options.ach) {
        glCallList (listIdAxis);
    }

    if (options.oloid || options.kuboid) {
	if (options.erzeugende) {
	  glCallList (listIdTime1);
	}
	if (options.endpunkte) {
	  glCallList (listIdTime2);
	}
    }

    if (options.touchline) {
        glCallList (listIdTouch);
    }
    
    glutSwapBuffers ();
}

void
WglReshape (int w, int  h) {

/*   static int grf = 0; */
/*   fprintf (stderr, "glutReshapeFunc %d\n", ++grf); */

    glutSetWindow (winIdMain);
    glViewport (0, 0, w, h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();

    if (options.perspektive) {
        /* glFrustum (-2.5, 2.5, -2.5, 2.5, 1.0, 10.0); */
        /* vert. angle, aspect ratio, near, far clipp */
        gluPerspective (60, 1., 1., 200.);
    }
    else {
        /* gute Gre fr Modus 1, um animated gif zu erstellen */
        /* glOrtho (-0.9, 2.5, -1.7, 1.7, -3.0, 7.0); */
        /* gute Gre fr Modus 2 und 3, um animated gif zu erstellen */
        glOrtho (-2.5, 2.5, -2.5, 2.5, -10.0, 10.0);
    }

    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();

    /* Invoke subwindow reshape */
    glutSetWindow (winIdSub);
    glutReshapeWindow (w, h / 7);
    glutPositionWindow (0, 0);
}

void
WglIdle (void) {
/*   static int gif = 0; */
    struct timeval tv;

#ifdef OS_WIN32
    /*
    ** Idle-Loop, wie funktioniert das vernnftig unter Windows ohne select?
    */
    int i, j;
    char buf[2];

    memcpy (&tv, &waittime, sizeof (struct timeval));
    if (tv.tv_usec < 0) {
        tv.tv_usec = - tv.tv_usec;
    }
    j = 1;
    for (i = 1; i < tv.tv_usec; i++) {
        buf[i/i] = buf[j/j];
    }
#else
    memcpy (&tv, &waittime, sizeof (struct timeval));
    select (0, NULL, NULL, NULL, &waittime);
    memcpy (&waittime, &tv, sizeof (struct timeval));
#endif

/*   fprintf (stderr, "glutIdleFunc %d\n", ++gif); */

    if (! halt) {
        WglNextPos ();
        WglPostRedisplay ();
    }
}

void
WglNextPos (void) {
    owgp = owgp->nextwgp ? owgp->nextwgp : wg;
    if (owgp == wg) {
        listIdLines = listIdLinesStart;
        listIdFill = listIdFillStart;
        listIdVirt = listIdVirtStart;
        listIdAxis = listIdAxisStart;
        listIdTime1 = listIdTime1Start;
        listIdTime2 = listIdTime2Start;
        listIdTouch = listIdTouchStart;
    }
    else {
        listIdLines++;
        listIdFill++;
        listIdVirt++;
        listIdAxis++;
        listIdTouch++;
    }
    if (options.tork) {
        torkle ();
    }
}

void
WglPrevPos (void) {
    owgp = owgp->prevwgp ? owgp->prevwgp : last;
    if (owgp == wg) {
        listIdLines = listIdLinesStart + anzpos;
        listIdFill = listIdFillStart + anzpos;
        listIdVirt = listIdVirtStart + anzpos;
        listIdAxis = listIdAxisStart + anzpos;
        listIdTouch = listIdTouchStart + anzpos;
    }
    listIdLines--;
    listIdFill--;
    listIdVirt--;
    listIdAxis--;
    listIdTouch--;
    if (options.tork) {
        torkle ();
    }
}

void
WglSubDisplay (void) {
    char label[128];

/*   static int gsdf = 0; */
/*   fprintf (stderr, "glutSubDisplayFunc %d\n", ++gsdf); */


    /* Clear subwindow */
    glutSetWindow (winIdSub);
    glClearColor (0.25, 0.25, 0.25, 0.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    /* Draw border */
    glColor3f (0.0, 1.0, 0.0);
    glBegin (GL_LINE_LOOP);
      glVertex2f (0., 0.);
      glVertex2f (0., 0.99);
      glVertex2f (0.999, 0.99);
      glVertex2f (0.999, 0.);
    glEnd ();

    /* Write State Variables */
    glColor3f (1.0, 1.0, 1.0);
    sprintf (label, "Modus = %s ", modus_txt[options.mode]);
    glRasterPos2f (0.02F, 0.82F);
    WglDrawString (label);

    sprintf (label, "Darstellung = %s ", darstellung_txt[options.lines]);
    glRasterPos2f (0.02F, 0.62F);
    WglDrawString (label);

    sprintf (label, "Schweben = %s ", options.tork ? "ein" : "aus");
    glRasterPos2f (0.02F, 0.42F);
    WglDrawString (label);

    sprintf (label, "Achsen = %s ", options.ach ? "ein" : "aus");
    glRasterPos2f (0.02F, 0.22F);
    WglDrawString (label);

    sprintf (label, "virtuelle Wrfelpunkte = %s ", options.virtuell ? "ein" : "aus");
    glRasterPos2f (0.02F, 0.04F);
    WglDrawString (label);

    /* Write Banner and info */

    sprintf (label, "Winkel = %6.0f ", GWINKEL (owgp->wgp.w) - 0.01);
    glRasterPos2f (0.4F, 0.82F);
    WglDrawString (label);

    sprintf (label, "Verschiebung x/y/z = %6.2f/%6.2f/%6.2f", tranx+dtranx, trany+dtrany, tranz+dtranz);
    glRasterPos2f (0.4F, 0.62F);
    WglDrawString (label);

    sprintf (label, "Rotation x/y/z = %6.2f/%6.2f/%6.2f",
	     (float)((int)rotx%360), (float)((int)roty%360), (float)((int)rotz%360));
    glRasterPos2f (0.4F, 0.42F);
    WglDrawString (label);

    sprintf (label, "(c) 2004 Franz Zahaurek, http://www.fzk.at");
    glRasterPos2f (0.4F, 0.04F);
    WglDrawString (label);

/*     Anzaige der aktuell dargestellten Display-Liste */
/*     sprintf (label, "DisplayLists %c%c%c%c%c%c", */
/* 	     callFill?'f':'_', callLines?'l':'_', callVirt?'v':'_', */
/* 	     callAxis?'a':'_', callTimeform?'t':'_', callTouchline?'b':'_'); */
/*     glRasterPos2f (0.8F, 0.82F); */
/*     WglDrawString (label); */

/*     glColor3f (1.0, 0.0, 1.0); */
/*     sprintf (label, " This is a subwindow "); */
/*     glRasterPos2f (0.40F, 0.70F); */
/*     WglDrawStringBig (label); */

/*     sprintf (label, " It has its own OpenGL context "); */
/*     glRasterPos2f (0.33F, 0.35F); */
/*     WglDrawStringBig (label); */

    if (options.info) {
      glutShowWindow();
    }
    else {
      glutHideWindow();
    }
    glutSwapBuffers ();
}

/* Callback function for reshaping the subwindow */
void
WglSubReshape (int w, int h)
{
    glViewport (0, 0, w, h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    /* gluOrtho2D (0.0, 1.0, 0.0, 1.0); */
    glOrtho (0.0, 1.0, 0.0, 1.0, -1., 1.);
}

void
WglPostRedisplay (void) {
    glutPostWindowRedisplay (winIdMain);
    glutPostWindowRedisplay (winIdSub);
}

/* Schweben: Verschiebung und Rotation zufllig steuern */
#define DELTA_T 0.01
#define DELTA_R 1.0
#define LIM_UPP_T 0.8
#define LIM_LOW_T -0.8
#ifdef OS_WIN32
#define ZUF               ((float)ranf (0.))
#else
#define ZUF               ((float)random () / (float)RAND_MAX)
#endif

void
torkle (void) {
    static BOOLEAN firsttime = TRUE;
    static float ddtranx, ddtrany, ddtranz, ddrotx, ddroty, ddrotz;
    static BOOLEAN xup = TRUE;
    static BOOLEAN yup = TRUE;
    static BOOLEAN zup = TRUE;

    if (firsttime || !owgp->nextwgp) {
        firsttime = FALSE;
        ddtranx = ZUF * DELTA_T;
        ddtrany = ZUF * DELTA_T;
        ddtranz = ZUF * DELTA_T;
        ddrotx = ZUF * DELTA_R;
        ddroty = ZUF * DELTA_R;
        ddrotz = ZUF * DELTA_R;
    }

    if (dtranx < LIM_LOW_T || LIM_UPP_T < dtranx) { xup = !xup;}
    if (dtrany < LIM_LOW_T || LIM_UPP_T < dtrany) { yup = !yup;}
    if (dtranz < LIM_LOW_T || LIM_UPP_T < dtranz) { zup = !zup;}

    dtranx += ddtranx * (xup ? 1. : -1.);
    dtrany += ddtrany * (yup ? 1. : -1.);
    dtranz += ddtranz * (zup ? 1. : -1.);
    drotx += ddrotx;
    drotx = drotx > 360. ? drotx - 360. : drotx;
    droty += ddroty;
    droty = droty > 360. ? droty - 360. : droty;
    drotz += ddrotz;
    drotz = drotz > 360. ? drotz - 360. : drotz;
}

char *
getErrorText (GLenum err) {
    switch (err) {
    case GL_INVALID_VALUE:
        return ("GL_INVALID_VALUE");
    case GL_INVALID_ENUM:
        return ("GL_INVALID_ENUM");
    case GL_INVALID_OPERATION:
        return ("GL_INVALID_OPERATION");
    case GL_STACK_OVERFLOW:
        return ("GL_STACK_OVERFLOW");
    case GL_STACK_UNDERFLOW:
        return ("GL_STACK_UNDERFLOW");
    case GL_OUT_OF_MEMORY:
        return ("GL_OUT_OF_MEMORY");
    default:
        return ("unknown errornum");
    }
}

void
WglTestGlError (char *text) {

    GLenum err;
    char * errText;

    err = glGetError ();
    if (err) {
        errText = getErrorText (err);
        fprintf (stderr, "%s: Error-Code = %d/%s\n", text, err, errText);
    }
}

void
WglDrawString (char *s)
{
  while (*s) {
    /*      glutBitmapCharacter (GLUT_BITMAP_9_BY_15, *s++); */
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_10, *s++);
  }
}

#ifdef OS_WIN32
/* Die Funktion ranf() entstammt dem Source-Code von gnuplot-3.7 */
/***********************************************************************
     double ranf(double init)
                RANDom number generator as a Function
     Returns a random floating point number from a uniform distribution
     over 0 - 1 (endpoints of this interval are not returned) using a
     large integer generator.
     This is a transcription from Pascal to Fortran of routine
     Uniform_01 from the paper
     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
     with Splitting Facilities." ACM Transactions on Mathematical
     Software, 17:98-111 (1991)

               GeNerate LarGe Integer
     Returns a random integer following a uniform distribution over
     (1, 2147483562) using the generator.
     This is a transcription from Pascal to Fortran of routine
     Random from the paper
     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
     with Splitting Facilities." ACM Transactions on Mathematical
     Software, 17:98-111 (1991)
***********************************************************************/
#define Xm1  2147483563L
#define Xm2  2147483399L
#define Xa1  40014L
#define Xa2  40692L

double ranf(init)
double init;
{

    long k, z;
    static int firsttime = 1;
    static long s1, s2;

    /* (Re)-Initialize seeds if necessary */
    if (init < 0.0 || firsttime == 1) {
        firsttime = 0;
        s1 = 1234567890L;
        s2 = 1234567890L;
    }
    /* Generate pseudo random integers */
    k = s1 / 53668L;
    s1 = Xa1 * (s1 - k * 53668L) - k * 12211;
    if (s1 < 0)
        s1 += Xm1;
    k = s2 / 52774L;
    s2 = Xa2 * (s2 - k * 52774L) - k * 3791;
    if (s2 < 0)
        s2 += Xm2;
    z = s1 - s2;
    if (z < 1)
        z += (Xm1 - 1);

    /*
     * 4.656613057E-10 is 1/Xm1.  Xm1 is set at the top of this file and is
     * currently 2147483563. If Xm1 changes, change this also.
     */
    return (double) 4.656613057E-10 *z;
}
#endif
